<template>
  <div class="spaceship" :style="spaceshipStyle"></div>
</template>

<script>
export default {
  data() {
    return {
      x: 50,
      y: 90
    };
  },
  computed: {
    spaceshipStyle() {
      return {
        left: this.x + '%',
        top: this.y + '%'
      };
    }
  },
  methods: {
    move(event) {
      if (event.key === 'ArrowLeft') this.x -= 1;
      if (event.key === 'ArrowRight') this.x += 1;
      if (event.key === 'ArrowUp') this.y -= 1;
      if (event.key === 'ArrowDown') this.y += 1;
      if (event.key === ' ') this.shoot();
    },
    shoot() {
      this.$emit('shoot', {
        x: this.x,
        y: this.y - 5
      });
    }
  },
  mounted() {
    window.addEventListener('keydown', this.move);
  },
  beforeUnmount() {
    window.removeEventListener('keydown', this.move);
  }
};
</script>

<style scoped>
.spaceship {
  position: absolute;
  width: 50px;
  height: 50px;
  background-color: white;
}
</style>
